﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace Exceptions_04
{
    public class Employee
    {
        public string Name { get; set; }
    }

    public class Janitor : Employee
    {
        public int BroomsOwned { get; set; }
    }

    public class Accountant : Employee 
    {
        public decimal MoneyLaundered { get; set; }
    }


    public interface IProcrastinator<T> { }

    public class Procrastinator<T> : IProcrastinator<T> { }


    /// <summary>
    /// All credit goes to David Kadlec, author of this demo sample
    /// </summary>
    class Program
    {
        private static void DisplayBroomsOwned(Employee employee)
        {
            var janitor = employee as Janitor;
            Console.WriteLine(janitor.BroomsOwned);
        }

        private static void DisplayBroomsOwned2(Employee employee)
        {
            var janitor = (Janitor)employee;
            Console.WriteLine(janitor.BroomsOwned);
        }

        private static void Covariant(IProcrastinator<Employee> slacker) { }

        private static void Covariant2(IEnumerable<Employee> employees) { }


        static void Main(string[] args)
        {
            var janitor = new Janitor() { BroomsOwned = 17 };
            var accountant = new Accountant() { MoneyLaundered = 7 };

            DisplayBroomsOwned(janitor);
            DisplayBroomsOwned2(janitor);
            try
            {
                DisplayBroomsOwned2(accountant);
            }
            catch (Exception e)
            {
                throw new Exception("kek", e);
            }

            var slacker = new Procrastinator<Employee>();
            var slackerJanitor = new Procrastinator<Janitor>();
            Covariant(slacker);
            //Covariant(slackerJanitor);

            var employee = new Employee();
            Covariant2(new List<Employee>() { employee });
            Covariant2(new List<Janitor>() { janitor });

            //string myMessage = "... catched.";

            //try
            //{
            //    DynamitMethod();
            //    Console.WriteLine("toto se neprovede");
            //}
            //catch (DynamiteException exc) 
            //{
            //    Console.WriteLine(exc.Message + myMessage);
            //}
            //catch (Exception exc) //when (exc is FormatException || exc is OverflowException)
            //{
            //    Console.WriteLine(exc.Message + myMessage);

            //    // reset callstacku - ztratim informaci o tom, kde k vyjimce doslo
            //    //throw exc;

            //    // zachova callstack
            //    //throw;

            //    // zachova callstack zaobalenim do nove vyjimky
            //    //throw new Exception("new exception", exc);
            //}
            //finally //provede se vzdy, i kdyz k vyjimce nedojde
            //{
            //    Console.ReadKey();
            //    // uvolneni zdroju, ...
            //}


            //// Nove lze v C# 7.0 vyhodit vyjimku v ramci vyrazu
            //var time = "10:08".Split(':');
            //var hours = time.Length == 2 ? time[0] : throw new InvalidOperationException("Invalid time format!");
        }

        public static void DynamitMethod()
        {
            //vyhodit vlastni vyjimku
            throw new DynamiteException("my dynamit exception", 20);

            // Vyhodime invalid operation
            //throw new InvalidOperationException("Invalid operation");
        }

        //bezne tridy vyjimek:
        // - Exception - doporucena MS pro vase vlastni vyjimky
        // - DivideByZeroException
        // - InvalidCastException
        // - InvalidOperationException
        // - ArgumentException
        // - ArgumentOutOfRangeException
    }
}
